<?php

namespace Ems\portalGestor\Controller;

use Ems\portalGestor\Service\FeriasService;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DTO;

class FeriasController {

    public function __construct(FeriasService $feriasService) {
        $this->feriasService = $feriasService;
    }

    public function getProgramacaoFerias(
        DTO\Request\Filter $request,
        DTO\Response $response
    ) {
        try {
            $row = $request->getParameters();

            $nrOrg              = (int) $row['NRORG'];
            $nrestruturam       = $row['NRESTRUTURAM'];
            $nrperiodoapuracao  = $row['NRPERIODOAPURACAO'];

            $progFerias = $this->feriasService->getProgramacaoFerias($nrOrg, $nrestruturam, $nrperiodoapuracao);

            // Data como nome default do dataset?
            $response->addDataSet(new DataSet('data', $progFerias));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

    public function setProgramacaoFerias(
        DTO\Request\Row     $request,
        DTO\Response        $response
    ) {
        try {
            $row = $request->getRow();

            $nrOrg      = (int) $row['NRORG'];
            $cdoperador = $row['CDOPERADOR'];
            $rows       = !empty($row['ROWS']) ? $row['ROWS'] : null;

            $progFerias = $this->feriasService->setProgramacaoFerias($nrOrg, $cdoperador, $rows);

            // Data como nome default do dataset?
            $response->addDataSet(new DataSet('data', $progFerias));
        } catch (\Exception $e) {
            $response->addMessage(new DTO\Response\Message($e->getMessage(), DTO\Response\Message::TYPE_ERROR));
        }
    }

}
